/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};define(["require","exports","jquery","TYPO3/CMS/Core/Ajax/AjaxRequest","TYPO3/CMS/Backend/Icons","TYPO3/CMS/Backend/Modal","./Renderable/InfoBox","./Renderable/ProgressBar","./Renderable/Severity"],(function(e,t,a,o,n,l,s,i,c){"use strict";a=__importDefault(a);return new class{constructor(){this.selectorBody=".t3js-body",this.selectorMainContent=".t3js-module-body"}initialize(){this.registerInstallToolRoutes(),a.default(document).on("click",".t3js-login-lockInstallTool",e=>{e.preventDefault(),this.logout()}),a.default(document).on("click",".t3js-login-login",e=>{e.preventDefault(),this.login()}),a.default(document).on("keydown","#t3-install-form-password",e=>{"Enter"===e.key&&(e.preventDefault(),a.default(".t3js-login-login").click())}),a.default(document).on("click",".t3js-modulemenu-action",e=>{e.preventDefault();const t=a.default(e.currentTarget);window.location.href=t.data("link")}),a.default(document).on("click",".card .btn",t=>{t.preventDefault();const o=a.default(t.currentTarget),s=o.data("require"),i=o.data("inline");if(void 0!==i&&1===parseInt(i,10))e([s],e=>{e.initialize(o)});else{const t=o.closest(".card").find(".card-title").html(),i=o.data("modalSize")||l.sizes.large,c=l.advanced({type:l.types.default,title:t,size:i,content:a.default('<div class="modal-loading">'),additionalCssClasses:["install-tool-modal"],callback:t=>{e([s],e=>{e.initialize(t)})}});n.getIcon("spinner-circle",n.sizes.default,null,null,n.markupIdentifiers.inline).then(e=>{c.find(".modal-loading").append(e)})}});"backend"===a.default(this.selectorBody).data("context")?this.executeSilentConfigurationUpdate():this.preAccessCheck()}registerInstallToolRoutes(){void 0===TYPO3.settings&&(TYPO3.settings={ajaxUrls:{icons:window.location.origin+window.location.pathname+"?install[controller]=icon&install[action]=getIcon",icons_cache:window.location.origin+window.location.pathname+"?install[controller]=icon&install[action]=getCacheIdentifier"}})}getUrl(e,t){const o=a.default(this.selectorBody).data("context");let n=location.href;return n=n.replace(location.search,""),void 0===t&&(t=a.default(this.selectorBody).data("controller")),n=n+"?install[controller]="+t,void 0!==o&&""!==o&&(n=n+"&install[context]="+o),void 0!==e&&(n=n+"&install[action]="+e),n}executeSilentConfigurationUpdate(){this.updateLoadingInfo("Checking session and executing silent configuration update"),new o(this.getUrl("executeSilentConfigurationUpdate","layout")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.executeSilentExtensionConfigurationSynchronization():this.executeSilentConfigurationUpdate()},e=>{this.handleAjaxError(e)})}executeSilentExtensionConfigurationSynchronization(){const e=a.default(this.selectorBody);this.updateLoadingInfo("Executing silent extension configuration synchronization"),new o(this.getUrl("executeSilentExtensionConfigurationSynchronization","layout")).get({cache:"no-cache"}).then(async t=>{if(!0===(await t.resolve()).success)this.loadMainLayout();else{const t=s.render(c.error,"Something went wrong","");e.empty().append(t)}},e=>{this.handleAjaxError(e)})}loadMainLayout(){const e=a.default(this.selectorBody);this.updateLoadingInfo("Loading main layout"),new o(this.getUrl("mainLayout","layout")).get({cache:"no-cache"}).then(async t=>{const o=await t.resolve();if(!0===o.success&&"undefined"!==o.html&&o.html.length>0){if(e.empty().append(o.html),"backend"!==a.default(this.selectorBody).data("context")){const t=e.data("controller");e.find('.t3js-modulemenu-action[data-controller="'+t+'"]').addClass("modulemenu-action-active")}this.loadCards()}else{const t=s.render(c.error,"Something went wrong","");e.empty().append(t)}},e=>{this.handleAjaxError(e)})}async handleAjaxError(e,t){let o;if(403===e.response.status){"backend"===a.default(this.selectorBody).data("context")?(o=s.render(c.error,"The install tool session expired. Please reload the backend and try again."),a.default(this.selectorBody).empty().append(o)):this.checkEnableInstallToolFile()}else{const n=this.getUrl(void 0,"upgrade");o=a.default('<div class="t3js-infobox callout callout-sm callout-danger"><div class="callout-body"><p>Something went wrong. Please use <b><a href="'+n+'">Check for broken extensions</a></b> to see if a loaded extension breaks this part of the install tool and unload it.</p><p>The box below may additionally reveal further details on what went wrong depending on your debug settings. It may help to temporarily switch to debug mode using <b>Settings > Configuration Presets > Debug settings.</b></p><p>If this error happens at an early state and no full exception back trace is shown, it may also help to manually increase debugging output in <code>typo3conf/LocalConfiguration.php</code>:<code>[\'BE\'][\'debug\'] => true</code>, <code>[\'SYS\'][\'devIPmask\'] => \'*\'</code>, <code>[\'SYS\'][\'displayErrors\'] => 1</code>,<code>[\'SYS\'][\'systemLogLevel\'] => 0</code>, <code>[\'SYS\'][\'exceptionalErrors\'] => 12290</code></p></div></div><div class="panel-group" role="tablist" aria-multiselectable="true"><div class="panel panel-default panel-flat searchhit"><div class="panel-heading" role="tab" id="heading-error"><h3 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#accordion" href="#collapse-error" aria-expanded="true" aria-controls="collapse-error" class="collapsed"><span class="caret"></span><strong>Ajax error</strong></a></h3></div><div id="collapse-error" class="panel-collapse collapse" role="tabpanel" aria-labelledby="heading-error"><div class="panel-body">'+await e.response.text()+"</div></div></div></div>"),void 0!==t?a.default(t).empty().html(o):a.default(this.selectorBody).empty().html(o)}}checkEnableInstallToolFile(){new o(this.getUrl("checkEnableInstallToolFile")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.checkLogin():this.showEnableInstallTool()},e=>{this.handleAjaxError(e)})}showEnableInstallTool(){new o(this.getUrl("showEnableInstallToolFile")).get({cache:"no-cache"}).then(async e=>{const t=await e.resolve();!0===t.success&&a.default(this.selectorBody).empty().append(t.html)},e=>{this.handleAjaxError(e)})}checkLogin(){new o(this.getUrl("checkLogin")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.loadMainLayout():this.showLogin()},e=>{this.handleAjaxError(e)})}showLogin(){new o(this.getUrl("showLogin")).get({cache:"no-cache"}).then(async e=>{const t=await e.resolve();!0===t.success&&a.default(this.selectorBody).empty().append(t.html)},e=>{this.handleAjaxError(e)})}login(){const e=a.default(".t3js-login-output"),t=i.render(c.loading,"Loading...","");e.empty().html(t),new o(this.getUrl()).post({install:{action:"login",token:a.default("[data-login-token]").data("login-token"),password:a.default(".t3-install-form-input-text").val()}}).then(async t=>{const a=await t.resolve();!0===a.success?this.executeSilentConfigurationUpdate():a.status.forEach(t=>{const a=s.render(t.severity,t.title,t.message);e.empty().html(a)})},e=>{this.handleAjaxError(e)})}logout(){new o(this.getUrl("logout")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success&&this.showEnableInstallTool()},e=>{this.handleAjaxError(e)})}loadCards(){const e=a.default(this.selectorMainContent);new o(this.getUrl("cards")).get({cache:"no-cache"}).then(async t=>{const a=await t.resolve();if(!0===a.success&&"undefined"!==a.html&&a.html.length>0)e.empty().append(a.html);else{const t=s.render(c.error,"Something went wrong","");e.empty().append(t)}},e=>{this.handleAjaxError(e)})}updateLoadingInfo(e){a.default(this.selectorBody).find("#t3js-ui-block-detail").text(e)}preAccessCheck(){this.updateLoadingInfo("Execute pre access check"),new o(this.getUrl("preAccessCheck","layout")).get({cache:"no-cache"}).then(async e=>{const t=await e.resolve();t.installToolLocked?this.checkEnableInstallToolFile():t.isAuthorized?this.executeSilentConfigurationUpdate():this.showLogin()},e=>{this.handleAjaxError(e)})}}}));